--[[
* barslib.lua
* (Author: CosmicPikachu)
* (July 7, 2022 00:43)
* Desc: Draws a bossbar to the screen with specified args
*
* Notes: Example usage - BarsLib.drawBossBar(v, boss, x, y, color, height, health, widthmultiplier, name, flags, align)
]]

rawset(_G, "BarsLib", {})

function BarsLib.isEggman(b)
	if b.type == MT_EGGMOBILE or b.type == MT_EGGMOBILE2
	or b.type == MT_EGGMOBILE3 or b.type == MT_EGGMOBILE4
		return true
	else
		return false
	end
end

function BarsLib.getBossName(b)
	local t = b.type
	if BarsLib.isEggman(b)
		return "Dr Eggman"
	else
		if t == MT_FANG
			return "Fang"
		elseif t == MT_METALSONIC_BATTLE
			return "Metal Sonic"
		elseif t == MT_CYBRAKDEMON
			return "Brak Eggman"
		else
			return t
		end
	end
end

function BarsLib.getBossHealth(b)
	return b.health
end

function BarsLib.getBarColor(b)
	local n = BarsLib.getBossName(b)
	if n == "Dr Eggman"
		if b.health > 3
			return 37
		else
			return 42
		end
	elseif n == "Fang"
		if b.health > 3
			return 164
		else
			return 166
		end
	elseif n == "Metal Sonic"
		if b.health > 3
			return 151
		else
			return 153
		end
	elseif n == "Brak Eggman"
		if b.health > 3
			return 39
		else
			return 44
		end
	else
		if b.health > 3
			return 34
		else
			return 37
		end
	end
end

function BarsLib.drawBossBar(v, b, x, y, barcolor, barheight, bosshealth, widthmul, bossname, flags, align)
	if b.type == MT_CYBRAKDEMON
		v.drawFill(x/2,y,mobjinfo[b.type].spawnhealth*widthmul, barheight-2,28)
		v.drawFill(x/2,y+barheight-2,mobjinfo[b.type].spawnhealth*widthmul,barheight-(barheight-2),31)
		v.drawFill(x/2,y,bosshealth*widthmul,barheight-2,barcolor)
		v.drawFill(x/2,y+barheight-2,bosshealth*widthmul,barheight-(barheight-2),barcolor+3)
		Fontlib.drawString(v, x+mobjinfo[b.type].spawnhealth*widthmul/4,y-barheight-9,bossname,flags,align)
	else
		v.drawFill(x,y,mobjinfo[b.type].spawnhealth*widthmul, barheight-2,28)
		v.drawFill(x,y+barheight-2,mobjinfo[b.type].spawnhealth*widthmul,barheight-(barheight-2),31)
		v.drawFill(x,y,bosshealth*widthmul,barheight-2,barcolor)
		v.drawFill(x,y+barheight-2,bosshealth*widthmul,barheight-(barheight-2),barcolor+3)
		Fontlib.drawString(v, x+mobjinfo[b.type].spawnhealth*widthmul/2,y-barheight-9,bossname,flags,align)
	end
end

addHook("BossThinker", function(b)
	BarsLib.Boss = b
	BarsLib.Boss.Name = BarsLib.getBossName(b)
--	if b.type == MT_CYBRAKDEMON
--		b.scale = FRACUNIT*3/2
--	end
end)

hud.add(function(v, p)
	if BarsLib.Boss and BarsLib.Boss.valid and BarsLib.Boss.health
		local distx = p.mo.x-BarsLib.Boss.x
		local disty = p.mo.y-BarsLib.Boss.y
		if distx < 1000*FRACUNIT and disty < 1000*FRACUNIT
			BarsLib.drawBossBar(v, BarsLib.Boss, 320/2-30, 185, BarsLib.getBarColor(BarsLib.Boss), 7, BarsLib.getBossHealth(BarsLib.Boss), 20, BarsLib.Boss.Name, V_SNAPTOBOTTOM and {font = "LTFNT", scale = FRACUNIT*3/4}, "center")
		end
	end
end,"game")